﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Diagnostics;

namespace howto_plinq_evens
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Generate a list of numbers and pick out the even ones.
        private void btnGo_Click(object sender, EventArgs e)
        {
            lstAllNumbers.DataSource = null;
            lstLinq.DataSource = null;
            lstPlinq.DataSource = null;
            lblLinq.Text = "";
            lblPlinq.Text = "";
            Cursor = Cursors.WaitCursor;
            Refresh();
            Stopwatch watch = new Stopwatch();

            // Create the numbers.
            watch.Start();
            Random rand = new Random();
            int num_numbers = int.Parse(txtNumNumbers.Text);
            int[] numbers = new int[num_numbers];
            for (int i = 0; i < numbers.Length; i++)
                numbers[i] = rand.Next(0, 100);
            watch.Stop();
            lstAllNumbers.DataSource = numbers.Take(1000).ToArray();
            lblRandom.Text = watch.Elapsed.TotalSeconds.ToString("0.00") + " secs";
            lblLinq.Refresh();
            lstAllNumbers.Refresh();

            // Use LINQ to find the even numbers.
            watch.Restart();
            var linq_query =
                from int number in numbers
                where number % 2 == 0
                select number;
            int[] linq_evens = linq_query.ToArray();
            watch.Stop();
            lstLinq.DataSource = linq_evens.Take(1000).ToArray();
            lblLinq.Text = watch.Elapsed.TotalSeconds.ToString("0.00") + " secs";
            lblLinq.Refresh();
            lstLinq.Refresh();

            // Use PLINQ to find the even numbers.
            watch.Restart();
            var plinq_query =
                from int number in numbers.AsParallel()
                where number % 2 == 0
                select number;
            int[] plinq_evens = plinq_query.ToArray();
            watch.Stop();
            lstPlinq.DataSource = plinq_evens.Take(1000).ToArray();
            lblPlinq.Text = watch.Elapsed.TotalSeconds.ToString("0.00") + " secs";

            Cursor = Cursors.Default;
        }
    }
}
